/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.14 by edhill, Fri Nov 7 21:32:19 2003 UTC revision 1.133 by jmc, Sat Jan 16 22:08:27 2010 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  #  $Header$  #  $Header$
4  #  $Name$  #  $Name$
# Line 11  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-mpi)                   use MPI input files"      echo "  (-mth)                   run multi-threaded (using eedata.mth)"
15        echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17      echo "  (-optfile=|-of=)STRING   list of optfiles to use"      echo "                             (DEF=\"-ieee\")"
18      echo "  (-a|-addr)STRING         list of email recipients"      echo "  (-gsl)                   compile with \"-gsl\" flag"
19      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "  (-of=|-optfile=)STRING   list of optfiles to use"
20      echo "  (-t|-tdir)STRING         list of test dirs to use"      echo "  (-a|-addr) STRING        list of email recipients"
21      echo "                             (DEF=\"\" which builds all)"      echo "                             (DEF=\"\" no email is sent)"
22      echo "  (-b|-bash)STRING         location of \"bash\" executable"      echo "  (-mpd|-mpackdir) DIR     location of the mpack utility"
23      echo "                             (DEF=\"\" for \"/bin/bash\")"      echo "                             (DEF=\"../tools/mpack-1.6\")"
24      echo "  (-command)STRING         command to run"      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
25        echo "                             (recognized groups: basic, tutorials)"
26        echo "                             (DEF=\"\" which test all)"
27        echo "  (-skd|-skipdir) STRING   list of exp. dirs to skip"
28        echo "                             (DEF=\"\" which test all)"
29        echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"
30        echo "                             Bourne-compatible \"sh\" shell"
31        echo "                             (DEF=\"\" for \"bash\")"
32        echo "  (-adm|-ad)               perform an adjoint run"
33        echo "  (-oad)                   perform an OpenAD adjoint run"
34        echo "  (-command) STRING        command to run"
35      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
36      echo "  (-m|-make)STRING         command to use for \"make\""      echo "  (-m|-make) STRING        command to use for \"make\""
37      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
38        echo "  (-odir) STRING           used to build output directory name"
39        echo "                             (DEF=\"hostname\")"
40        echo "  (-ptr|-ptracers) STRING  specify which ptracers to test"
41        echo "                             (DEF=\"1 2 3 4 5\")"
42        echo "  (-match) NUMBER          Matching Criteria (number of digits)"
43        echo "                             (DEF=\"12\")"
44        echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
45      echo "  (-clean)                 *ONLY* run \"make CLEAN\""      echo "  (-clean)                 *ONLY* run \"make CLEAN\""
46        echo "  (-norun|-nr)             skip the \"runmodel\" stage (stop after make)"
47      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
48      echo "  (-nogenmake|-ng)         skip the genmake stage"      echo "  (-nogenmake|-ng)         skip the genmake stage"
49      echo "  (-noclean|-nc)           skip the \"make clean\" stage"      echo "  (-noclean|-nc)           skip the \"make clean\" stage"
50      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"
51        echo "  (-deldir|-dd)            on success, delete the output directory"
52        echo "  (-ts)                    provide timing information per timestep"
53        echo "  (-papis)                 provide MFlop/s per timestep using PAPI"
54        echo "  (-pcls)                  provide MFlop/s per timestep using PCL"
55      echo      echo
56      echo "and where STRING follows a whitespace-delimited format"      echo "and where STRING can be a whitespace-delimited list"
57      echo "such as:"      echo "such as:"
58        echo
59      echo "  -t 'exp0 exp2 exp3' "      echo "  -t 'exp0 exp2 exp3' "
60      echo "  -addr='abc@123.com testing@home.org'"      echo "  -addr='abc@123.com testing@home.org'"
61      echo      echo
62        echo "provided that the expression is properly quoted within the current"
63        echo "shell (note the use of single quotes to protect white space)."
64        echo
65      exit 1      exit 1
66  }  }
67    
68  #  build the mpack utility  #  build the mpack utility
69  build_mpack()  build_mpack()
70  {  {
71      echo -n "building the mpack utility...  "      printf "building the mpack utility...  "
72      if test ! -x "$MPACKDIR/mpack" ; then      MPACK="$MPACKDIR/mpack"
73        if test ! -x $MPACK ; then
74          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
75                echo
76              echo "Error: can't find \"$MPACKDIR\""              echo "Error: can't find \"$MPACKDIR\""
77              echo "  are you sure this program is being run in the correct "              echo "  are you sure this program is being run in the correct "
78              echo "  (that is, \"MITGCM_ROOT\verification\") directory?"              echo "  (that is, \"MITGCM_ROOT\verification\") directory?"
79              exit 1              echo
80                HAVE_MPACK=f
81          fi          fi
82          echo -n "building mpack...  "          if test "x$CC" = x ; then
83          ( cd $MPACKDIR && ./configure && $MAKE ) > build_mpack.out 2>&1              export CC=cc
84            fi
85            printf "building mpack (using CC=$CC)...  "
86            ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
87          RETVAL=$?          RETVAL=$?
88          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
89              echo              echo
90              echo "Error building the mpack tools at: $MPACK_DIR"              echo "Error building the mpack tools at: $MPACK_DIR"
91              exit 1              echo
92                HAVE_MPACK=f
93            else
94                rm -f tr_build_mpack.out
95                HAVE_MPACK=t
96                echo "done"
97          fi          fi
98        else
99            HAVE_MPACK=t
100            echo "already exist"
101      fi      fi
     echo "OK"  
 }  
   
 compare_lines()  
 {  
     # use codelet to compare lines  
     if [ $verbose -gt 1 ]; then  
         cat tmp3.txt 1>&2  
     fi  
     return `./a.out < tmp3.txt`  
102  }  }
103    
104  testoutput_for_prop()  testoutput_var()
105  {  {
106      # testoutput_for_prop dir s1 label subdir      # testoutput_var dir s1 label subdir reference_output
107      #      #
108      #  compares files in $dir/$subdir/output.txt and $dir/results/output.txt      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
109      #  using search strings s1 and text label      #     with same output from reference file $dir/results/$reference_output
110        #  using search strings s1 and text label
111    
112      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
113          echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2          echo testoutput_var: grep "$2" $1/$4/$OUTPUTFILE 1>&2
114      fi      fi
115      if [ -r $1/$4/output.txt ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
116          grep "$2" $1/$4/output.txt | sed 's/.*=//' | nl > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt
117          lncnt=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
118          if [ $lncnt -lt 3 ]; then          if [ $lncntA -lt 2 ]; then
119              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
120                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
121              fi              fi
122              return 99              return 99
123          fi          fi
124      else      else
125          echo testoutput_for_prop: output.txt from model run was not readable 1>&2          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2
126          return 99          return 99
127      fi      fi
128      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
129          echo testoutput_for_prop: grep "$2" $1/results/output.txt 1>&2          echo testoutput_var: grep "$2" $1/results/$5 1>&2
130      fi      fi
131      grep "$2" $1/results/output.txt | sed 's/.*=//' | nl > tmp2.txt      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt
132      lncnt=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
133      if [ $lncnt -lt 3 ]; then      if [ $lncntB -lt 2 ]; then
134          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
135              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
136          fi          fi
137          return 99          return 99
138      fi      fi
139        if [ $lncntA -ne $lncntB ]; then
140            if [ $verbose -gt 0 ]; then
141                echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2
142            fi
143            return 99
144        fi
145        has_nan=`cat tmp1.txt | grep -i nan | wc -l`
146        if [ $has_nan -gt 0  ] ; then
147            echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2
148            return 99
149        fi
150        has_inf=`cat tmp1.txt | grep -i inf | wc -l`
151        if [ $has_inf -gt 0  ] ; then
152            echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2
153            return 99
154        fi
155      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
156          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2
157      fi      fi
158      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt
159      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
160          echo testoutput_for_prop: compare_lines 1>&2          echo testoutput_var: compare_lines 1>&2
161        fi
162        if [ $verbose -gt 1 ]; then
163            cat tmp3.txt 1>&2
164      fi      fi
165      compare_lines      echo "-1" >> tmp3.txt
166      digits_of_similarity=$?      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
167        cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
168        digits_of_similarity=`./tr_cmpnum < tmp4.txt`
169      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
170          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
171              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2              echo testoutput_var: No comparison was available for \"$3\" 1>&2
172          fi          fi
173          digits_of_similarity=99          digits_of_similarity=99
174      else      else
175          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
176              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
177          fi          fi
178      fi      fi
179      rm tmp1.txt tmp2.txt tmp3.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
180            
181      return $digits_of_similarity      return $digits_of_similarity
182  }  }
183    
184  dashnum()  testoutput_run()
185  {  {
186      # dashnum n1 n2 n3 ...      # testoutput_run directory subdir reference_output
187      #      #
188      #  print numbers using %3i format or "--" if number = 99      #  test output from 1 run in "directory"
189    # --> same processing for adjoint & forward test
190      for num in $@ ; do          # default list of output variables to be checked:
191          if [ $num = 99 ]; then          #  1rst : main variable used to decide if it pass or FAIL
192              printf ' --'          #  others : number of matching digits to be printed in summary.txt
193          else          listChk=$DEF_CHECK_LIST
194              printf '%3i' $num          #  load experiment-specific list from file "tr_checklist" (if it exist)
195          fi          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
196      done          sVar=`echo $listChk | awk '{print $1}'`
197  }          # remove 1rst var and expand the list: + => min max mean s.d
198            listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
199  testoutput()                                 | sed 's/+//g' | sed "s/^$sVar//"`
200  {          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
201      # testoutput diretory subdir          # check for ptracer output in reference_output file :
202      #          outpref=$1/results/$3
203      #  test output in "directory"          ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
204            ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
205      if [ $debug -gt 0 ]; then          for ii in $PTRACERS_NUM ; do
206          echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2              ptrfound=0
207      fi              for jj in $ptr_mon ; do
208      testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2; cg2dres=$?                  name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
209      if [ $debug -gt 0 ]; then                  tst=`grep $name $outpref | wc -l | awk '{print $1}'`
210          echo testoutput: cg2dres=$cg2dres 1>&2                  if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
211      fi              done
212      testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2; tmin=$?              if test $ptrfound = '1' ; then
213      testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2; tmax=$?                  eval "HAVE_PTR0"$ii"=t"
214      testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2; tmean=$?              else
215      testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2; tsd=$?                  eval "HAVE_PTR0"$ii"=f"
216      testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2; smin=$?                if test "x$ADM" = x -a "x$OADM" = x; then
217      testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2; smax=$?                # remove this ptr from the list of output variable to check
218      testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2; smean=$?                # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
219      testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2; ssd=$?                  listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
220      testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2; umin=$?                fi
221      testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2; umax=$?              fi
222      testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2; umean=$?          #   eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
223      testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2; usd=$?          done
224      testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2; vmin=$?          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
225      testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2; vmax=$?          if test $tst != 1 ; then
226      testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2; vmean=$?            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
227      testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2; vsd=$?                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
228                  echo "==> WARNING: in checked list:" $listVar 1>&2
229      dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \          #- put it back once:
230          $umin $umax $umean $usd $vmin $vmax $vmean $vsd            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
231            fi
232            if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
233            echo "listVar='$listVar'" > $CDIR"/summary.txt"
234            allargs=""
235            for xx in $listVar
236            do
237              case $xx in
238               'PS')  if [ $debug -gt 0 ]
239                      then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
240                      testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?
241                      if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
242              'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;
243              'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;
244               'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;
245               'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;
246               'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;
247               'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;
248               'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;
249               'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;
250               'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;
251               'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;
252               'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;
253               'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;
254               'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;
255               'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;
256               'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;
257               'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;
258               'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;
259               'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;
260            'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
261               testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;
262            'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
263               testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $3; yy=$? ;;
264            'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
265               testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
266            'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
267               testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
268             'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
269             'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
270             'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $3; yy=$? ;;
271             'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
272             'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
273             'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
274             'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
275             'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;
276             'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;
277             'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Heff max"   $2 $3; yy=$? ;;
278             'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Heff mean"  $2 $3; yy=$? ;;
279             'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Heff StDv"  $2 $3; yy=$? ;;
280            'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;
281            'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;
282            'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;
283            'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;
284            'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;
285            'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;
286                  *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
287              esac
288              if test $xx = $sVar
289              then allargs="$allargs > $yy <"
290              else allargs="$allargs $yy"
291              fi
292            done
293    
294            nbVar=`echo $listVar | awk '{print NF}'`
295            if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
296            #-- fill line (up to standard length) with dot:
297              adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
298              echo $allargs $adNul
299            else
300              echo $allargs
301            fi
302    # <-- same processing for adjoint & forward test
303  }  }
304    
305  genmakemodel()  genmakemodel()
# Line 183  genmakemodel() Line 308  genmakemodel()
308      if test "x$NOGENMAKE" = xt ; then      if test "x$NOGENMAKE" = xt ; then
309          echo "genmake skipped!"          echo "genmake skipped!"
310      else      else
311          GENMAKE2="$BASH ../../../tools/genmake2"          if test "x$BASH" = x ; then
312                GENMAKE2="../../../tools/genmake2"
313            else
314                GENMAKE2="$BASH ../../../tools/genmake2 -bash $BASH"
315            fi
316          (          (
317              cd $1;              cd $1;
318              command="$GENMAKE2  -ds -m $MAKE --mods=../code"              command="$GENMAKE2  -ds -m $MAKE"
319                if test "x$ADM" = xt ; then
320                    command="$command --mods=../code_ad"
321                elif test "x$OADM" = xt ; then
322                    command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"
323                else
324                    command="$command -mods=../code"
325                fi
326              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
327                  command="$command --optfile=$OPTFILE"                  command="$command -optfile=$OPTFILE"
                 # echo "  command=\"$command\""  
328              fi              fi
329              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
330                  command="$command -ieee"                  command="$command -ieee"
331              fi              fi
332              # echo "command: \"$command\""              if test "x$GSL" = xt ; then
333                    command="$command -gsl"
334                fi
335                if test "x$MPI" = xt ; then
336                    command="$command -mpi"
337                fi
338                if test "x$MULTI_THREAD" = xt ; then
339                #- run multi-threaded using OpenMP:
340                    command="$command -omp"
341                fi
342                if test "x$TS" = xt ; then
343                    command="$command -ts"
344                fi
345                if test "x$PAPIS" = xt ; then
346                    command="$command -papis"
347                else
348                if test "x$PCLS" = xt ; then
349                    command="$command -pcls"
350                fi
351                fi
352              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
353              $command > make.log 2>&1              # $command > make.log 2>&1
354                eval $command > make.log 2>&1
355              RETVAL=$?              RETVAL=$?
356              for i in genmake_state genmake_optfile genmake_local Makefile ; do              #  Reduce the size of the testing emails!
357                  if test -r $i ; then              head -100 Makefile > $CDIR/Makefile_head
                     cp $i $CDIR  
                 fi  
             done  
358              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
359                  tail make.log                  tail make.log
360                  echo "genmakemodel: genmake failed" 1>&2                  echo "genmakemodel: genmake failed" 1>&2
361                  cp make.log $CDIR                  cp genmake_* make.log $CDIR
362                  return 1                  return 1
363              else              else
364                  echo "succesful" 1>&2                  echo "successful" 1>&2
365              fi              fi
366          )          )
367      fi      fi
# Line 219  makeclean() Line 371  makeclean()
371  {  {
372      # makeclean directory      # makeclean directory
373      if test "x$NOCLEAN" = xt ; then      if test "x$NOCLEAN" = xt ; then
374          echo "make CLEAN skipped!"          echo "make Clean skipped!"
375      else      else
376          (          (
377              cd $1;              cd $1;
378              if test -e output.txt ; then              #if test -e $OUTPUTFILE ; then rm -f $OUTPUTFILE ; fi
                 rm -f output.txt  
             fi  
             printf 'make CLEAN ... ' 2>&1  
379              if test -r Makefile ; then              if test -r Makefile ; then
380                  $MAKE CLEAN >> make.log 2>&1                  printf 'clean build-dir: make Clean ... ' 2>&1
381                    $MAKE Clean >> make.log 2>&1
382                  RETVAL=$?                  RETVAL=$?
383                  if test "x$RETVAL" != x0 ; then                  if test "x$RETVAL" != x0 ; then
384                      tail make.log                      tail make.log
385                      echo "makeclean: \"make CLEAN\" failed" 1>&2                      echo "makeclean: \"make Clean\" failed" 1>&2
386                      cp make.log $CDIR"/make.log"                      cp make.log $CDIR"/make.log"
387                      return 1                      return 1
388                  fi                  fi
389                    echo successful 1>&2
390                else
391                    echo ''
392              fi              fi
393              echo succesful 1>&2              exit 0
394            )
395        fi
396    }
397    
398    run_clean()
399    {
400        # run_clean directory
401        if test "x$NOCLEAN" = xt ; then
402            echo "run_clean skipped!"
403        else
404            (
405                cd $1;
406                printf 'clean run-dir ... ' 2>&1
407                # part of what is done after "make clean" when doing "make CLEAN"
408                find . -name "*.meta" -exec rm {} \;
409                find . -name "*.data" -exec rm {} \;
410                find . -name "fort.*" -exec rm {} \;
411                find . -type l -exec rm {} \;
412                rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
413                rm -rf mnc_test_*
414                rm -f *_MIT_CE_000.opt0000 costfunction*0000
415                echo successful 1>&2
416              exit 0              exit 0
417          )          )
418      fi      fi
# Line 260  makedependmodel() Line 435  makedependmodel()
435                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
436                  return 1                  return 1
437              else              else
438                  echo succesful 1>&2                  echo successful 1>&2
439              fi              fi
440          )          )
441      fi      fi
# Line 273  makemodel() Line 448  makemodel()
448          cd $1;          cd $1;
449          if test -r Makefile ; then          if test -r Makefile ; then
450              printf 'make ... ' 1>&2              printf 'make ... ' 1>&2
451              $MAKE >> make.log 2>&1              if test "x$ADM" = xt ; then
452                    $MAKE adall >> make.log 2>&1
453                elif test "x$OADM" = xt ; then
454                    $MAKE adAll >> make.log 2>&1
455                else
456                    if test "x$JOBS" = x ; then
457                        $MAKE >> make.log 2>&1
458                    else
459                        $MAKE -j $JOBS >> make.log 2>&1
460                    fi
461                fi
462              RETVAL=$?              RETVAL=$?
463              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
464                  tail make.log                  tail make.log
465                  echo failed 1>&2                  echo failed 1>&2
466                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
467                    rm -f $EXECUTABLE
468                  return 1                  return 1
469              else              else
470                  echo succesful 1>&2                  echo successful 1>&2
471              fi              fi
472          fi          fi
473      )      )
474  }  }
475    
476    symlink_mpifiles()
477    {
478        # Put special links so that MPI specific files are used
479        # This MUST be invoked between makeclean and makelinks because
480        # the Makefile will link to non-mpi files by default
481    
482        dir=$1
483        code_dir=$2
484        BUILD_DIR=$dir/$3
485        CODE_DIR=$dir/$code_dir
486        
487        # These are files that should replace their counter-part when using -mpi
488        MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
489    
490        #  Is this an MPI run?
491        if test "x$MPI" = xt ; then
492            # YES: We symbolically link these files to the build
493            # dir so long as there is no real file in place
494            for ii in $MPI_FILES ; do
495                i=`echo $ii | sed 's:^\./::'`
496                name=`echo $i | sed 's:_mpi::' `
497                cmp $CODE_DIR/$i $BUILD_DIR/$name > /dev/null 2>&1
498                RETVAL=$?
499                if test "x$RETVAL" != x0 ; then
500                    if ! test -f $BUILD_DIR/$i ; then
501                        #echo Linking $name to $i
502                        (cd $BUILD_DIR; ln -sf ../$code_dir/$i $name)
503                    fi
504                fi
505            done
506        else
507            # NO: We undo any _mpi symbolically linked files
508            for ii in $MPI_FILES ; do
509                i=`echo $ii | sed 's:^\./::'`
510                name=`echo $i | sed 's:_mpi::' `
511                if test -L $BUILD_DIR/$name ; then
512                    cmp $BUILD_DIR/$name "../$code_dir/$name"_mpi > /dev/null 2>&1
513                    RETVAL=$?
514                    if test "x$RETVAL" = x0 ; then
515                        #echo Un-linking $name from $linktarg
516                        rm -f $BUILD_DIR/$name
517                    fi
518                fi
519            done
520        fi
521        
522    }
523    
524  linkdata()  linkdata()
525  {  {
526      # linkdata flag      # linkdata run_dir input_dir_1 input_dir_2 ...
527      #      #
528      # symbolically link data files to run directory      # symbolically link data files to run directory
529      if test "x$1" = x1 ; then      if test -d $1 ; then
530          (          (
531              cd $2              cd $1 ; shift
532              files=`( cd ../input ; ls -1 | grep -v CVS )`              inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`
533              for i in $files ; do              for xx in $inpMPI ; do
534                  if test ! -d "../input/"$i ; then                if test -r "../"$1"/"$xx ; then
535                      ln -sf "../input/"$i $i                  # found 1 _mpi sfx file in 1rst input dir and it is readable
536                    yy=`echo $xx | sed 's:\.mpi$::'`
537                    if test "x$MPI" = "xt" ; then
538                    # mpi test: remove symbolic link & link _mpi sfx file
539                        if test -h $yy ; then rm -f $yy ; fi
540                        if test ! -r $yy ; then
541                            ln -sf "../"$1"/"$xx $yy ;
542                            printf "$xx " 1>&2
543                        fi
544                    else
545                    # not mpi test: remove symbolic link
546                        if test -h $yy ; then rm -f $yy ; fi
547                    fi
548                  fi
549                done
550                if test -r "../"$1"/eedata.mth" ; then
551                # found eedata.mth in 1rst input dir and it is readable
552                    if test "x$MULTI_THREAD" = "xt" ; then
553                    # multi-threaded test: remove symbolic link & link eedata.mth
554                        if test -h eedata ; then rm -f eedata ; fi
555                        if test ! -r eedata ; then
556                            ln -sf "../"$1"/eedata.mth" eedata ;
557                            printf 'eedata.mth ' 1>&2
558                        fi
559                    else
560                    # not multi-threaded test: remove eedata symbolic link
561                        if test -h eedata ; then rm -f eedata ; fi
562                    fi
563                fi
564                prevDir='NONE'
565                for ldir in $* ; do
566                    if test -d "../"$ldir -a $ldir != $prevDir ; then
567                        printf 'ldir='${ldir} 1>&2
568                        files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
569                        for i in $files ; do
570                            if test ! -d "../"$ldir/$i ; then
571                                if test ! -r $i  ; then
572                                    printf ' '$i 1>&2
573                                    ln -sf "../"$ldir"/"$i $i
574                                fi
575                            fi
576                        done
577                        if test -x "../"$ldir"/"prepare_run ; then
578                            "../"$ldir"/"prepare_run
579                        fi
580                        printf ' ; ' 1>&2
581                  fi                  fi
582                    prevDir=$ldir
583              done              done
584          )          )
585      fi      fi
# Line 309  runmodel() Line 589  runmodel()
589  {  {
590      # runmodel directory      # runmodel directory
591      #      #
592      #  runs "$COMMAND" in "directory"      #  runs "$COMMAND in "directory"
593      #  (where "$COMMAND" is relative to "directory")      #  (where "$COMMAND" is relative to "directory")
594      (      (
595          cd $1          cd $1
596          printf 'runmodel: ' 1>&2          printf 'runmodel in %s ...' $1 1>&2
597          # make output.txt          # make output.txt
598          $COMMAND          echo
599          RETVAL=$?          if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
600          if test "x$RETVAL" = x0 ; then              diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
601              cp output.txt $CDIR"/output.txt"              outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; fi
602            fi
603            if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
604                echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
605                ln -sf "../"$builddir"/"$EXECUTABLE .
606            fi
607            if test ! -x $EXECUTABLE ; then
608                    rm -f $RUNLOG ; touch $RUNLOG
609                    if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
610                    echo " no executable:" $EXECUTABLE >> $RUNLOG
611                    RETVAL=8
612                    ENDVAL=-1
613            else
614                if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
615                  # output do not exist or is older than executable:
616                    rm -f $RUNLOG ; touch $RUNLOG
617                    if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
618                    ( eval $COMMAND ) >> $RUNLOG 2>&1
619                    RETVAL=$?
620                else
621                    RETVAL=0
622                    if test -f $RUNLOG ; then
623                        if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
624                        echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
625                    else
626                        touch $RUNLOG
627                        if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
628                        echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
629                        echo " no previous $RUNLOG: assume NORMAL END" >> $RUNLOG 2>&1
630                    fi
631                fi
632                ENDVAL=`cat $RUNLOG | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
633            fi
634            rm -f run.log_tmp
635            if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
636                tail $RUNLOG
637                echo successful 1>&2
638                # === Reduce the size of the testing emails!
639                #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
640                if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
641                return 0
642            elif [ $RETVAL -ne 0 -a $ENDVAL -gt 0 ] ; then
643                #-- for some weird cases (run is finihed but with error code)
644                tail $RUNLOG
645                echo finished with error '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
646              return 0              return 0
647          else          else
648                tail $RUNLOG
649                echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
650                cp $RUNLOG $CDIR"/"$RUNLOG
651                if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
652              return 1              return 1
653          fi          fi
654      )      )
# Line 330  createcodelet() Line 658  createcodelet()
658  {  {
659      # create codelet for comparing model output      # create codelet for comparing model output
660    
661      echo -n "creating the comparison code...  "      printf "creating the comparison code (using CC=$CC)...  "
662      cat > tmp_cmpnum.f <<EOFA      cat > tr_cmpnum.c <<EOF
663        program cmpnum  #include <stdio.h>
664        implicit none  #include <math.h>
665        real*8 a,b,diff  int main( int argc, char** argv )  {
666        integer linnum,best    int linnum,cmplin,best,lncnt;
667        best=-16    double a,b,abave,relerr;
668    99  read(*,*,end=70,err=60) linnum,a,b    best = -22;
669        diff=0.5*(abs(a)+abs(b))    lncnt = 0;
670  c     print *,a,b,diff,abs(a-b)/diff    while( 1 & ( (lncnt+=1) < 999 ) )  {
671        if (diff.gt.1.e-12) then      scanf("%d", &linnum);
672          diff=abs(a-b)/diff      if (linnum == -1)  break;
673          if (diff.gt.0.) then      scanf("%lf", &a);  scanf("%lf", &b);
674  c         print *,int(log10(diff)),diff      abave = 0.5*(fabs(a)+fabs(b));
675            linnum=int(log10(diff))      if ( abave == abave ) {
676            best=max(best,linnum)        if (abave > 0.0) {
677          endif          relerr=fabs(a-b)/abave;
678        else          if (relerr > 0.0) { cmplin = (int)rint(log10(relerr)); }
679          if (best.eq.-16.and.diff.ne.0.) best=-22          else { cmplin = -16 ; }
680        endif          best = (best > cmplin) ? best : cmplin; }
681        goto 99        else { cmplin = -22 ; }
682    60  stop 'cmpnum: An error occured reading a,b'     /* printf("%d ; %lf ; %lf\n",cmplin,a,b); */
683    70  print *,-best        }
684        end     else {
685  EOFA     /* printf("%lf ; %lf ; %lf\n",abave,a,b); */
686          break; }
687      }
688      if (lncnt == 999) best=-29;
689      if (linnum != -1) best=-99;
690      printf("%d\n", -best);
691      return 0;
692    }
693    EOF
694        $CC -o tr_cmpnum tr_cmpnum.c -lm
695    
696      f77 tmp_cmpnum.f      if [ -x ./tr_cmpnum ]; then
     if [ -x ./a.out ]; then  
697          echo "OK"          echo "OK"
698          return 0          return 0
699      else      else
700          echo          echo
701          echo "createcodelet: failed to compile codelet"          echo "ERROR: failed to compile comparison code -- please specify"
702            echo "  a C compiler using the CC environment variable."
703          exit 1          exit 1
704      fi      fi
705  }  }
# Line 374  formatresults() Line 711  formatresults()
711      nm=$1      nm=$1
712      printf '%s %s %s %s' $2 $3 $4 $5      printf '%s %s %s %s' $2 $3 $4 $5
713      shift; shift; shift; shift; shift;      shift; shift; shift; shift; shift;
714      printf '%3s' $@      listPrt=$@
715        listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`
716        xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`
717        printf '%3s' $listPrt
718    #   line below does not work on hp-ux_ia64 : do those substitutions later on
719    #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
720            
721      if [ $1 = '--' ]; then      if [ $xx = '..' ]; then
722            printf ' N/O '
723        elif [ $xx = '--' ]; then
724            printf ' N/O '
725        elif [ $xx = 99 ]; then
726          printf ' N/O '          printf ' N/O '
727      else      else
728          if [ $1 -gt 12 ]; then          if [ $xx -ge $MATCH_CRIT ]; then
729              printf ' pass'              printf ' pass'
730          else          else
731              printf ' FAIL'              printf ' FAIL'
# Line 390  formatresults() Line 736  formatresults()
736            
737  }  }
738    
739  show_help()  scandirs()
740  {  {
741      cat - << EOF      if [ $# -eq 1 ]; then
742  $0 [-help] [-quick] [-verbose] dir1 [dir2] [...]          for arg in * ; do
743                test -f $arg/$1 && echo $arg
744   -help|-h      Show this help message          done
745   -quiet     Reduce the amount of output      else
746   -verbose   Produce copious amounts of output          echo $*
747   -debug     Produce even more output which will mean nothing to most      fi
  -force     Do "make CLEAN" before compiling. This forces a complete rebuild.  
  -clean     Do "make CLEAN" after compiling and testing.  
  -cleanup   Aggresively removes all model output, executables and object files  
             and then exits. Use with care.  
   
 Normal usage:  
  $0 *       Configure, compile, run and analyze in all experiment directories  
 EOF  
748  }  }
749    
750  scandirs()  
751    check_eedata()
752  {  {
753      if [ $# -eq 0 ]; then      # check_eedata size.h eedata
754          for arg in * ; do      if [ $# -eq 2 ] ; then
755              test -d $arg/input && echo $arg        if test -f $1 -a -f $2 ; then
756          done        sx=`grep "^     & *nSx *=" $1 | sed "s/^     & *nSx *=//" | sed 's/, *$//'`
757          nx=`grep "^ *nTx *=" $2 | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
758          if test "x$nx" = x ; then
759            rx=10
760          else
761            rx=`expr $sx % $nx`
762          fi
763          sy=`grep "^     & *nSy *=" $1 | sed "s/^     & *nSy *=//" | sed 's/, *$//'`
764          ny=`grep "^ *nTy *=" $2 | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
765          if test "x$ny" = x ; then
766            ry=20
767          else
768            ry=`expr $sy % $ny`
769          fi
770          echo `expr $rx + $ry`
771        else
772          echo '-1'
773          fi
774      else      else
775          echo $*        echo '-2'
776      fi      fi
 }  
777    
778    }
779    
780  ###############################################################################  ###############################################################################
 ###############################################################################  
 ###############################################################################  
781    
782    
783  #  Default properties  #  Default properties
784  debug=0  debug=0
785  verbose=1  verbose=1
786  clean=0  clean=0
 expts=''  
 # ieee=1  
787    
788  IEEE=  IEEE=true
789  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
790      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
791  fi  fi
792    GSL=f
793    
794  CLEANUP=f  CLEANUP=f
795    NORUN=f
796  QUICK=f  QUICK=f
797  NOGENMAKE=f  NOGENMAKE=f
798  NOCLEAN=f  NOCLEAN=f
799  NODEPEND=f  NODEPEND=f
800    POSTCLEAN=f
801    
802  BASH=  BASH=
803  OPTFILE=NONE  OPTFILE=NONE
804  ADDRESSES=  ADDRESSES=
805  TESTDIRS=  TESTDIRS=
806    SKIPDIRS=
807  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
808  MPACK="$MPACKDIR/mpack"  HAVE_MPACK=
809  COMMAND="make output.txt"  MPACK=
810  MAKE=make  COMMAND=
811    if test "x$MAKE" = x ; then
812        MAKE=make
813    fi
814    if test "x$CC" = x ; then
815        CC=cc
816    fi
817    JOBS=
818  MPI=f  MPI=f
819    MULTI_THREAD=f
820    OUTDIR=
821    DELDIR=
822    
823    ADM=
824    OADM=
825    
826    # list of pTracers to check for monitor output
827    PTRACERS_NUM="1 2 3 4 5"
828    
829  echo -n "parsing options...  "  MATCH_CRIT=13
830    
831    printf "parsing options...  "
832    
833  ac_prev=  ac_prev=
834  for ac_option ; do  for ac_option ; do
# Line 483  for ac_option ; do Line 856  for ac_option ; do
856              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
857          -addr=* | --addr=*)          -addr=* | --addr=*)
858              ADDRESSES=$ac_optarg ;;              ADDRESSES=$ac_optarg ;;
859            -mpackdir | --mpackdir | -mpd | --mpd)
860                ac_prev=MPACKDIR ;;
861            -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*)
862                MPACKDIR=$ac_optarg ;;
863    
864          -tdir | --tdir | -t | --t)          -tdir | --tdir | -t | --t)
865              ac_prev=TESTDIRS ;;              ac_prev=TESTDIRS ;;
866          -tdir=* | --tdir=*)          -tdir=* | --tdir=*)
867              TESTDIRS=$ac_optarg ;;              TESTDIRS=$ac_optarg ;;
868    
869            -skipdir | --skipdir | -skd | --skd)
870                ac_prev=SKIPDIRS ;;
871            -skipdir=* | --skipdir=*)
872                SKIPDIRS=$ac_optarg ;;
873    
874          -bash | --bash | -b | --b)          -bash | --bash | -b | --b)
875              ac_prev=BASH ;;              ac_prev=BASH ;;
876          -bash=* | --bash=*)          -bash=* | --bash=*)
# Line 504  for ac_option ; do Line 886  for ac_option ; do
886          -make=* | --make=*)          -make=* | --make=*)
887              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
888    
889            -odir | --odir)
890                ac_prev=OUTDIR ;;
891            -odir=* | --odir=*)
892                OUTDIR=$ac_optarg ;;
893    
894            -ptracers | --ptracers | -ptr | --ptr)
895                ac_prev=PTRACERS_NUM ;;
896            -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)
897                PTRACERS_NUM=$ac_optarg ;;
898    
899            -match | --match ) ac_prev=MATCH_CRIT ;;
900            -match=* | --match=* ) MATCH_CRIT=$ac_optarg ;;
901    
902            -j) ac_prev=JOBS ;;
903            -j=*) JOBS=$ac_optarg ;;
904    
905          -clean | --clean)          -clean | --clean)
906              CLEANUP=t ;;              CLEANUP=t ; DELDIR=t ;;
907    
908            -norun | --norun | -nr | --nr)
909                NORUN=t ;;
910          -quick | --quick | -q | --q)          -quick | --quick | -q | --q)
911              QUICK=t ;;              QUICK=t ;;
912          -nogenmake | --nogenmake | -ng | --ng)          -nogenmake | --nogenmake | -ng | --ng)
# Line 516  for ac_option ; do Line 916  for ac_option ; do
916          -nodepend | --nodepend | -nd | --nd)          -nodepend | --nodepend | -nd | --nd)
917              NODEPEND=t ;;              NODEPEND=t ;;
918    
919          -mpi) MPI=true ;;          -postclean | --postclean | -pc | --pc)
920                POSTCLEAN=t ;;
921    
922            -mpi) MPI=t ;;
923    
924            -mth) MULTI_THREAD=t ;;
925    
926            -adm | -ad) ADM=t ;;
927    
928            -oad) OADM=t; NODEPEND=t ;;
929    
930          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
931          -noieee) IEEE= ;;          -noieee) IEEE= ;;
932            -gsl) GSL=t ;;
933    
934          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
935          -debug) debug=1 ;;          -debug) debug=1 ;;
936          -quiet) verbose=0 ;;          -quiet) verbose=0 ;;
937    
938            -deldir | -dd) DELDIR=t ;;
939    
940            -ts) TS=t;;
941    
942            -papis) PAPIS=t;;
943    
944            -pcls) PCL=t;;
945    
946          -*)          -*)
947              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
948              usage              usage
# Line 545  if test "x$QUICK" = xt ; then Line 963  if test "x$QUICK" = xt ; then
963      NODEPEND=t      NODEPEND=t
964  fi  fi
965    
966    #- setting for forward or ADM testing
967    if test "x$ADM" = xt ; then
968        code_dir=code_ad
969        inputdir=input_ad
970        ref_outp="output_adm.txt"
971        EXECUTABLE="mitgcmuv_ad"
972    elif test "x$OADM" = xt ; then
973        code_dir=code_oad
974        inputdir=input_oad
975        ref_outp="output_oadm.txt"
976        EXECUTABLE="mitgcmuv_ad"
977    else
978        code_dir=code
979        inputdir=input
980        ref_outp="output.txt"
981        EXECUTABLE="mitgcmuv"
982    fi
983    
984  if test "x$TESTDIRS" = x ; then  if test "x$TESTDIRS" = x ; then
985      TESTDIRS=`scandirs`      LIST=`scandirs results/$ref_outp`
986    else
987        #- expand group of experiments:
988        LIST=" "
989        for xx in $TESTDIRS
990        do
991          case $xx in
992            'basic') LIST=${LIST}" aim.5l_cs hs94.128x64x5 ideal_2D_oce"
993                     LIST=${LIST}" lab_sea tutorial_baroclinic_gyre"
994                     LIST=${LIST}" tutorial_global_oce_latlon tutorial_plume_on_slope"
995                    ;;
996            'tutorials')
997                     LIST=${LIST}" "`ls | grep 'tutorial_'` ;;
998            *)       LIST=${LIST}" "$xx ;;
999          esac
1000        done
1001  fi  fi
1002    #echo 'LIST='${LIST}'<'
1003    #- skip dirs, remove duplicate and non-directory:
1004    TESTDIRS=" "
1005    count=0
1006    for xx in $LIST
1007    do
1008        yy=`echo $SKIPDIRS | grep -c $xx`
1009        if test $yy = 0 ; then
1010            if test -d $xx ; then
1011                yy=`echo $TESTDIRS | grep -c $xx`
1012                if test $yy = 0 ; then TESTDIRS=${TESTDIRS}" "$xx ; fi
1013            else count=1 ;
1014                echo ""; echo -n " -- skip \"$xx\" (not a directory !)"
1015            fi
1016        else
1017            if test $count = 1 ; then echo -n ", \"$xx\""
1018            else count=1 ; echo "" ;  echo -n " skip: \"$xx\""
1019            fi
1020        fi
1021    done
1022    if test $count = 1 ; then echo "" ; echo -n " ... " ; fi
1023    #echo 'TESTDIRS='${TESTDIRS}'<'
1024    
1025  if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then  if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then
1026      OPTFILE=$MITGCM_OF      OPTFILE=$MITGCM_OF
1027  fi  fi
1028    
1029  echo "OK"  RUNLOG="run.log"
1030    OUTPUTFILE=$ref_outp
1031    if test "x$COMMAND" = x ; then
1032        COMMAND="./$EXECUTABLE > $OUTPUTFILE"
1033    fi
1034    if test "x$MPI" = xt ; then
1035        OUTPUTFILE="STDOUT.0000"
1036    fi
1037    
1038    echo "OK (COMMAND= $COMMAND )"
1039    
1040    # set the Default List of output variables to be checked:
1041    #  (use default or load experiment-specific list from file "tr_checklist")
1042    # content : 1rst = main variable used to decide if it pass or FAIL
1043    #         others = number of matching digits to be printed in summary.txt
1044    if test "x$ADM" = x -a "x$OADM" = x; then
1045        DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
1046        EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
1047        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1048        ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
1049        EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
1050    else
1051        DEF_CHECK_LIST='Grad Cost Grad'
1052        EMPTY_RESULTS='.. ..'
1053        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1054    fi
1055    
1056  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1057  createcodelet  if test -x tr_cmpnum ; then
1058        echo "skipping comparison code build"
1059    else
1060        createcodelet
1061    fi
1062    
1063  #  build the mpack utility  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
1064  build_mpack  if test "x$ADDRESSES" = x ; then
1065        echo "skipping mpack build"
1066    else
1067        build_mpack
1068    fi
1069    
1070  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
1071    CMDLINE=$0
1072    for xx in "$@" ; do nw=`echo $xx | wc -w`
1073        if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"
1074                            else CMDLINE="$CMDLINE '$xx'" ; fi
1075    done
1076    #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
1077  MACH=`hostname`  MACH=`hostname`
1078  UNAMEA=`uname -a`  UNAMEA=`uname -a`
1079  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
1080  BASE=$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
1081    if test "x$OUTDIR" != x ; then
1082        BASE="tr_"$OUTDIR"_"$DATE"_"
1083    else
1084        short_name=`hostname | sed 's/\..*$//'`
1085        BASE="tr_"$short_name"_"$DATE"_"
1086    fi
1087  DNUM=0  DNUM=0
1088  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
1089  while test -e $DRESULTS ; do  while test -e $DRESULTS ; do
# Line 575  done Line 1093  done
1093  mkdir $DRESULTS  mkdir $DRESULTS
1094  RETVAL=$?  RETVAL=$?
1095  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
1096      echo "Error: can't create results directory \"./$DRESULTS\""      echo "ERROR: Can't create results directory \"./$DRESULTS\""
1097      exit 1      exit 1
1098  fi  fi
1099  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
1100  echo -n "Start time:  " >> $SUMMARY  start_date=`date`
1101  date > $SUMMARY  echo $start_date > $SUMMARY
1102  date > dfile  echo 'run:' $CMDLINE >> $SUMMARY
1103  cat << EOF >> $SUMMARY  echo 'on :' $UNAMEA  >> $SUMMARY
                 T           S           U           V  
 G D M    c        m  s        m  s        m  s        m  s  
 E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .  
 N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d  
 2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .  
   
 EOF  
   
 NDIR=0  
1104    
1105  of_path=  of_path=
1106  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
# Line 605  if test "x$OPTFILE" != xNONE ; then Line 1114  if test "x$OPTFILE" != xNONE ; then
1114          fi          fi
1115          file=${OPTFILE##*/}          file=${OPTFILE##*/}
1116          OPTFILE=$of_path/$file          OPTFILE=$of_path/$file
1117            cp $OPTFILE $DRESULTS
1118            echo >> $SUMMARY
1119            echo "  OPTFILE=$OPTFILE" >> $SUMMARY
1120      else      else
1121          echo          echo | tee $SUMMARY
1122          echo "WARNING: can't read OPTFILE=\"$OPTFILE\" but will try to use it..."          echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee $SUMMARY
1123            exit 1
1124      fi      fi
1125    else
1126        echo >> $SUMMARY
1127        echo "No \"OPTFILE\" was explicitly specified by testreport," >> $SUMMARY
1128        echo "   so the genmake default will be used." >> $SUMMARY
1129  fi  fi
1130  echo  echo
 echo "OPTFILE=$OPTFILE" >> $SUMMARY  
1131  echo >> $SUMMARY  echo >> $SUMMARY
1132    if test "x$ADM" = x -a "x$OADM" = x; then
1133        if [ $MATCH_CRIT -lt 10 ] ;
1134        then line_0="default  "$MATCH_CRIT ;
1135        else line_0="default "$MATCH_CRIT ; fi
1136           line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1137    #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"
1138        line_1="G D M    c        m  s        m  s        m  s        m  s"
1139        line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
1140        line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1141        line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1142        for ii in $PTRACERS_NUM ; do
1143            line_0="$line_0  --PTR 0"$ii"--"
1144            line_1="$line_1        m  s"
1145            line_2="$line_2  m  m  e  ."
1146            line_3="$line_3  i  a  a  d"
1147            line_4="$line_4  n  x  n  ."
1148        done
1149        echo "$line_0" | tee -a $SUMMARY
1150        echo "$line_1" | tee -a $SUMMARY
1151        echo "$line_2" | tee -a $SUMMARY
1152        echo "$line_3" | tee -a $SUMMARY
1153        echo "$line_4" | tee -a $SUMMARY
1154        echo " "       | tee -a $SUMMARY
1155    else
1156        echo "ADJOINT=true" >> $SUMMARY
1157        echo >> $SUMMARY
1158        if [ $MATCH_CRIT -lt 10 ] ;
1159        then line_0="default     "$MATCH_CRIT ;
1160        else line_0="default    "$MATCH_CRIT ; fi
1161        echo "$line_0" | tee -a $SUMMARY
1162        cat << EOF | tee -a $SUMMARY
1163    G D M    C  G
1164    E p a R  o  r
1165    N n k u  s  a
1166    2 d e n  t  d
1167    
1168    EOF
1169    fi
1170    
1171  #  ...and each test directory...  #  ...and each test directory...
1172  for dir in $TESTDIRS ; do  for dir in $TESTDIRS ; do
1173            
1174        # set builddir & rundir:
1175        builddir="build"
1176        if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1177        rundir="run"
1178        if test ! -d $dir/$rundir ; then
1179            rundir=$builddir
1180        fi
1181        CODE_DIR=$dir/$code_dir
1182        BUILD_DIR=$dir/$builddir
1183    
1184      #  Cleanup only!      #  Cleanup only!
1185      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1186          if test -r $dir/build/Makefile ; then          echo -n '  --- dir:' $BUILD_DIR ': '
1187              ( cd $dir/build ; make CLEAN )          makeclean $BUILD_DIR
1188            rm -f $BUILD_DIR/$EXECUTABLE
1189            if test -d $dir/$rundir/CVS ; then
1190                echo -n '  --- dir:' $dir/$rundir ': '
1191                run_clean $dir/$rundir
1192          fi          fi
1193          if test -r $dir/input/Makefile ; then          trdir=`( cd $dir ; find . -type d -name "tr_run.*" -print | sed 's/^.\///')`
1194              ( cd $dir/input ; make CLEAN )          ttd=`echo $trdir | wc -w`
1195            if test $ttd != 0 ; then
1196                echo '  --- rm dir:' $trdir
1197                ( cd $dir ; rm -rf $trdir )
1198          fi          fi
1199          continue          continue
1200      fi      fi
1201    
1202      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1203      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1204      if test ! -r $dir"/results/output.txt" ; then      fout=$dir"/results/"$ref_outp
1205          echo "can't read \"$dir/results/output.txt\" -- skipping $dir"      if test ! -r $fout ; then
1206            echo "can't read \"$fout\" -- skipping $dir"
1207          continue          continue
1208      fi      fi
1209    
1210      echo "-------------------------------------------------------------------------------"      # Check for specific files for particular type of run
     echo  
     echo "Experiment:  $dir"  
     echo  
     unset genmake makedepend make run  
     results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'  
1211    
1212      builddir="input"      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1213      rundir="input"          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
1214      use_seperate_build=0          continue
     if test -d $dir/build -a -r $dir/build ; then  
         builddir="build"  
         rundir="build"  
         use_seperate_build=1  
         linkdata $use_seperate_build $dir/$rundir  
1215      fi      fi
1216            if test ! -r $dir"/input/eedata.mth" -a "x$MULTI_THREAD" = "xt" ; then
1217      CODE_DIR=$dir/code          echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"
1218      BUILD_DIR=$dir/$builddir          continue
     MPI_FILES="CPP_EEOPTIONS.h_mpi SIZE.h_mpi"  
     NOMPI_FILES="CPP_EEOPTIONS.h_nompi SIZE.h_nompi"  
   
     #  Is this an MPI run?  
     if test "x$MPI" = xt ; then  
         FILES=$MPI_FILES  
         endings="_mpi"  
     else  
         FILES=$NOMPI_FILES  
         endings="_nompi"  
1219      fi      fi
1220            if test "x$MPI" = "xt" -a "x$MULTI_THREAD" = "xt" ; then
1221      #  Check to see that we have the files        retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/input/eedata.mth"`
1222      have_files=t        if test $retv != 0 ; then
1223      for i in $FILES ; do          echo "input/eedata.mth tiling misfit -- skipping $dir"
         if test ! -r $CODE_DIR/$i ; then  
             echo "Warning: can't read file $CODE_DIR/$i"  
             have_files=f  
         fi  
     done  
     if test "x$have_files" != xt -a "x$MPI" = xt ; then  
         echo "Skipping $dir due to lack of input files (see above warning)"  
1224          continue          continue
1225          fi
1226      fi      fi
1227        
1228      #  If we have the $FILES and they differ, copy the $FILES to $BUILD_DIR      #  Check whether there are "extra runs" for this testdir
1229      if test "x$have_files" = xt ; then      extra_runs=
1230          for i in $FILES ; do      if test "x$NORUN" = xf ; then
1231              sstr="s|$endings||"          ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1232              name=`echo $i | sed -e $sstr `      fi
1233              cmp $CODE_DIR/$i $BUILD_DIR/$name > /dev/null 2>&1      #echo "ex_run_dirs='$ex_run_dirs'"
1234              RETVAL=$?      for exd in $ex_run_dirs ; do
1235              if test "x$RETVAL" != x0 ; then          name=`echo $exd | sed -e "s/$inputdir\.//"`
1236                  cp $CODE_DIR/$i $BUILD_DIR/$name          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1237            outf="$dir/results/$refExOut"
1238            if test -f $outf -a -r $outf ; then
1239              if test "x$MULTI_THREAD" = "xt" ; then
1240                if test -r $dir"/"$exd"/eedata.mth" ; then
1241                  if test "x$MPI" = "xt" ; then
1242                    retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/"$exd"/eedata.mth"`
1243                    if test $retv = 0 ; then
1244                        extra_runs="$extra_runs $name"
1245                    else
1246                        echo $exd"/eedata.mth tiling misfit -- skipping $dir"
1247                    fi
1248                  else
1249                    extra_runs="$extra_runs $name"
1250                  fi
1251                #else echo $dir"/"$exd"/eedata.mth: not found"
1252              fi              fi
1253          done            else
1254                extra_runs="$extra_runs $name"
1255              fi
1256            fi
1257        done
1258    
1259        echo "-------------------------------------------------------------------------------"
1260        echo
1261        if test "x$extra_runs" = "x" ; then
1262           echo "Experiment:  $dir"
1263        else
1264           echo "Experiment:  $dir ; extra_runs=$extra_runs"
1265      fi      fi
1266            echo
1267        unset genmake makedepend make run
1268        results=$EMPTY_RESULTS
1269    
1270      #  Create an output dir for each OPTFILE/tdir combination      #  Create an output dir for each OPTFILE/tdir combination
1271      CDIR=$DRESULTS"/"$DRESULTS"_"$NDIR      rel_CDIR=$DRESULTS"/"$dir
1272      mkdir $CDIR      mkdir $rel_CDIR
1273      CDIR=`pwd`"/$CDIR"      CDIR=`pwd`"/$rel_CDIR"
1274            
1275      if test "x$CLEANUP" = xt ; then      if test "x$NORUN" = xt ; then
1276          makeclean $dir/$builddir              run=N
1277            genmakemodel $dir/$builddir && genmake=Y \
1278                && makeclean $dir/$builddir \
1279                && run_clean $dir/$rundir \
1280                && symlink_mpifiles $dir $code_dir $builddir \
1281                && makedependmodel $dir/$builddir && makedepend=Y \
1282                && makemodel $dir/$builddir && make=Y
1283      else      else
1284          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1285              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
1286                && run_clean $dir/$rundir \
1287                && symlink_mpifiles $dir $code_dir $builddir \
1288              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1289              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1290              && linkdata $use_seperate_build $dir/$rundir \              && linkdata $dir/$rundir $inputdir input \
1291              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1292              && results=`testoutput $dir $rundir`              && results=`testoutput_run $dir $rundir $ref_outp`
1293      fi      fi
1294            
1295        #echo "results='$results'"
1296      echo      echo
1297      formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1298          ${run:-N} $results          echo
1299      echo          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1300      formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \          touch $CDIR"/summary.txt"
1301          ${run:-N} $results >> $SUMMARY          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1302      echo "fresults='" > $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1303      formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1304          ${run:-N} $results >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1305      echo "'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1306      echo "MACH='$MACH'" >> $CDIR"/summary.txt"          if test "x$ADM" = xt ; then
1307      echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1308      echo "DATE='$DATE'" >> $CDIR"/summary.txt"              grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1309      echo "tdir='$dir'" >> $CDIR"/summary.txt"                                  >> $CDIR"/summary.txt"
       
     (  
         cd $DRESULTS  
         tar -cf $NDIR".tar" $DRESULTS"_"$NDIR > /dev/null 2>&1  
         gzip $NDIR".tar"  
     )  
       
     if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  
         echo "No mail sent"  
     else  
         $MPACK -s MITgcm-test -m 1000000 $DRESULTS"/"$NDIR".tar.gz" $ADDRESSES  
         RETVAL=$?  
         if test "x$RETVAL" != x0 ; then  
             echo "Warning: \"$MPACK\" failed -- please contact <edhill@mitgcm.org>"  
         else  
             rm -f $DRESULTS"/"$NDIR".tar*"  
1310          fi          fi
     fi  
1311    
1312      echo "-------------------------------------------------------------------------------"          for ex in $extra_runs ; do
1313                unset run
1314                results=$EMPTY_RESULTS
1315                #  reference output file
1316                refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1317                #  Create an output dir for each OPTFILE/tdir.ex combination
1318                rel_CDIR=$DRESULTS"/"$dir"."$ex
1319                mkdir $rel_CDIR
1320                CDIR=`pwd`"/$rel_CDIR"
1321                test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1322                run_clean $dir/tr_run.$ex
1323                linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input
1324                runmodel $dir/tr_run.$ex && run=Y \
1325                && results=`testoutput_run $dir tr_run.$ex $refExOut`
1326                fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1327                fres="$fres.$ex"
1328                echo
1329                echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1330                touch $CDIR"/summary.txt"
1331                echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1332                echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1333                echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1334                echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1335                echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1336                if test "x$ADM" = xt ; then
1337                    head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1338                    grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \
1339                                       >> $CDIR"/summary.txt"
1340                fi
1341                if test "x$POSTCLEAN" = xt ; then
1342                    run_clean $dir/tr_run.$ex
1343                fi
1344            done
1345    
1346        #postclean $dir/$builddir
1347        if test "x$POSTCLEAN" = xt ; then
1348            makeclean $dir/$builddir \
1349                && run_clean $dir/$rundir
1350        fi
1351            
1352      NDIR=$(( $NDIR + 1 ))      echo "-------------------------------------------------------------------------------"
1353            
1354  done  done
1355    
1356  echo -n "Start time:  " >> $SUMMARY  printf "Start time:  " >> $SUMMARY
1357  date -r dfile >> $SUMMARY  echo "$start_date" >> $SUMMARY
1358  echo -n "End time:    " >> $SUMMARY  printf "End time:    " >> $SUMMARY
1359  date >> $SUMMARY  date >> $SUMMARY
1360    
1361  rm tmp_cmpnum.f a.out dfile  #  If addresses were supplied and mpack built successfully, then try
1362    #  to send email using mpack.
1363    if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
1364        echo "No results email was sent."
1365    else
1366        if test "x$HAVE_MPACK" = xt ; then
1367            tar -cf $DRESULTS".tar" $DRESULTS > /dev/null 2>&1 \
1368                && gzip $DRESULTS".tar" \
1369                && $MPACK -s MITgcm-test -m 3555000 $DRESULTS".tar.gz" $ADDRESSES
1370            RETVAL=$?
1371            if test "x$RETVAL" != x0 ; then
1372                echo
1373                echo "Warning: The tar, gzip, & mpack step failed.  Please send email"
1374                echo "  to <MITgcm-support@mitgcm.org> for help.  You may copy the "
1375                echo "  summary of results from the directory \"$DRESULTS\"."
1376                echo
1377            else
1378                echo
1379                echo "An email containing results was sent to the following addresses:"
1380                echo "  \"$ADDRESSES\""
1381                echo
1382                test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"
1383                test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"
1384            fi
1385        fi
1386    fi
1387    
1388    if test "x$QUICK" = xf -a "x$NORUN" = xf ; then
1389        rm -f tr_cmpnum.c tr_cmpnum
1390    fi
1391    
1392  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1393      cat $SUMMARY      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
1394      if test -e tr.out ; then      if test -e tr_out.txt ; then
1395          mv tr.out tr.out.old          mv tr_out.txt tr_out.txt.old
1396      fi      fi
1397      cat $SUMMARY > tr.out      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1398    fi
1399    
1400    if test "x$DELDIR" = xt ; then
1401        rm -rf $DRESULTS
1402  fi  fi
1403    

Legend:
Removed from v.1.14  
changed lines
  Added in v.1.133

  ViewVC Help
Powered by ViewVC 1.1.22